﻿using System;
using Newtonsoft.Json;
using System.Linq;

namespace Oxide.Plugins
{
    [Info("CentralBan", "MikeHawke", "1.0.0")]
    [Description("CentralBan system")]
    class CentralBan : RustPlugin
    {
        #region config
        private ConfigData configData;
        class ConfigData
        {
            [JsonProperty(PropertyName = "API URL")]
            public String url = "http://www.YOURDOMAIN.com/API/post/create.php";
        }
        void Init()
        {
            if (!LoadConfigVariables())
            {
                Puts("Config file issue detected. Please delete file, or check syntax and fix.");
                return;
            }
        }
        private bool LoadConfigVariables()
        {
            try
            {
                configData = Config.ReadObject<ConfigData>();
            }
            catch
            {
                return false;
            }
            SaveConfig(configData);
            return true;
        }
        protected override void LoadDefaultConfig()
        {
            Puts("Creating new config file.");
            configData = new ConfigData(); SaveConfig(configData);
        }
        void SaveConfig(ConfigData config)
        {
            Config.WriteObject(config, true);
        }
        #endregion

        private class BanData
        {
            [JsonProperty("steamId")]
            public string steamId { get; set; }
            [JsonProperty("reason")]
            public string reason { get; set; }
            [JsonProperty("expiryDate")]
            public string expiryDate { get; set; }
            public class Get : BanData
            { }
            public class Post : BanData
            { }
            public string ToJson()
            {
                return JsonConvert.SerializeObject(this);
            }
        }
        [ConsoleCommand("CentralFirstRun")]
        void FirstRun(ConsoleSystem.Arg args)
        {
            int refnum = 0;
            var banned = ServerUsers.GetAll(ServerUsers.UserGroup.Banned).ToList();
            for (int i = 0; i < banned.Count; i++)
            {
                Puts((i + 1).ToString());
                timer.Once(i + 1, () =>
                {
                    string expiryDate = "0000-00-00 00:00:00";
                    string steamid = banned[refnum].steamid.ToString();
                    string reason = banned[refnum].notes;
                    AddBan(steamid, reason, expiryDate);
                    refnum++;
                });
            }
        }
        private void OnUserBanned(string name, string steamid, string address, string reason)
        {
            string expiryDate = "0000-00-00 00:00:00";
            AddBan(steamid, reason, expiryDate);
        }
        private void AddBan(string steamId, string reason, string expiryDate)
        {
            string PostURL = configData.url;
            string ServerIP = ConVar.Server.ip;
            webrequest.Enqueue(PostURL, new BanData.Post
            {
                steamId = steamId,
                reason = reason,
                expiryDate = expiryDate,
            }.ToJson(), (code, response) =>
            {
                if (code == 200)
                {
                    Puts($"{steamId} Added To Central system");
                }
                else
                {
                    Puts("BanNotLogged", response);
                }
            }, this, Core.Libraries.RequestMethod.POST);
        }
    }
}