<?php
    class Post {
        private $conn;
        private $table = 'API';
        public $id;
        public $steamId;
        public $reason;
        public $expiryDate;
        public function __construct($db){
            $this->conn = $db;
        }   
        public function read_single() {
             $query = 'SELECT
             p.steamId,
             p.reason,
             p.expiryDate
             FROM
             ' . $this->table . ' p
            WHERE p.steamId = ?
            LIMIT 0,1';
            $stmt = $this->conn->prepare($query);
            $stmt->bindParam(1, $this->steamId);
            $stmt->execute();
            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            $this ->steamId = $row['steamId'];
            $this ->reason = $row['reason'];
            $this ->expiryDate = $row['expiryDate'];
        }
        public function create() {
            $query = 'INSERT INTO ' . $this->table . '
            SET
            steamId = :steamId,
            reason = :reason,
            expiryDate = :expiryDate';
            $stmt = $this->conn->prepare($query);
            $this->reason = htmlspecialchars(strip_tags($this->reason));
            $stmt->bindParam(':steamId', $this->steamId);
            $stmt->bindParam(':reason', $this->reason);
            $stmt->bindParam(':expiryDate', $this->expiryDate);
            if($stmt->execute()) {
                return true;
            }
            printf("Error: %s.\n", $stmt->error);
            return false;
        }
    }